#!/bin/sh
#
# To use this filter with less, define LESSOPEN:
# export LESSOPEN="|/usr/local/bin/lesspipe.cma.sh %s"

if [ -d ${1} ]; then
	ls -alFR ${1} 2>/dev/null
elif [ -f ${1} ]; then
	FILE=$(file -bL ${1})
	LFAIL=0
	[ ! "$(echo ${FILE} | grep text)" -a "$(head -c 1048576 ${1} | strings)" ] && echo -e ${FILE} "\n"
	case "${FILE}" in
		"GNU tar"*)
			{ tar -tvvf ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		gzip*|compress\'d*)
			{ tar -tzvvf ${1} || gzip -dc ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		bzip2*)
			{ tar -tIvvf ${1} || bzip2 -dc ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		bzip*)
			{ tar --us=bzip -tvvf ${1} || bzip -dc ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		Zip*|PKZIP*|Info-ZIP*)
			{ unzip -l ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		ARJ*)
			{ unarj l ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		LZH*|LH[Aa]*)
			{ lha -v ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		RAR*)
			{ unrar vt -v ${1} || rar vt -v ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		ARC*)
			{ arc v ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		Zoo*)
			{ zoo VCm/ ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		RPM*)
			{ rpm -qilvp ${1} || LFAIL=1 ; } \
				2>/dev/null
			;;
		troff*)
			{ groff -s -p -t -e -Tascii -mandoc ${1} || LFAIL=1 ; }
			;;
		*)
			LFAIL=1
			;;
	esac
	if [ "${LFAIL}" = "1" ]; then
		{ [ ! "$(echo ${FILE} | grep text)" -a ! "$(echo ${FILE} | grep 669)" ] && \
		strings ${1} ; }
	fi
fi
